com.dlsc.flexgantt.swing.timeline

## Class AbstractDatelineRenderer<T extends IDatelineModel>

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JLabel
        - - com.dlsc.flexgantt.swing.timeline.AbstractDatelineRenderer<T>

- Type Parameters:
    `T` - the type of the dateline model
  All Implemented Interfaces:
    IDatelineRenderer<T>, IRenderer, ImageObserver, MenuContainer, Serializable, Accessible, SwingConstants
  Direct Known Subclasses:
    SimpleGranularityDatelineRenderer, TimeGranularityDatelineRenderer

      public abstract class AbstractDatelineRenderer<T extends IDatelineModel>
      extends JLabel
      implements IDatelineRenderer<T>

  An abstract dateline renderer that provides common functionality for its subclasses. This common functionality primarily consists of several methods to lookup colors used for the foreground and background of major and minor time spans.
  Since:
    1.0
  Version:
    $Revision: 1.9 $
  Author:
    Dirk Lemmermann
  See Also:
    `Dateline.setDatelineRenderer(Class, IDatelineRenderer)`, Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.JLabel

      `JLabel.AccessibleJLabel`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

  - ### Field Summary

    - ### Fields inherited from class javax.swing.JLabel

      `labelFor`

    - ### Fields inherited from class javax.swing.JComponent

      `listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface javax.swing.SwingConstants

      `BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NEXT, NORTH, NORTH_EAST, NORTH_WEST, PREVIOUS, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractDatelineRenderer()` Constructs a new dateline renderer and initializes the forground and background colors for calendar entries that are of type or subclasses of `WeekendCalendarEntry` and `HolidayCalendarEntry`.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `firePropertyChange(String propertyName, boolean oldValue, boolean newValue)` Overriden for performance reasons.
    `void` | `firePropertyChange(String propertyName, byte oldValue, byte newValue)` Overriden for performance reasons.
    `void` | `firePropertyChange(String propertyName, char oldValue, char newValue)` Overriden for performance reasons.
    `void` | `firePropertyChange(String propertyName, double oldValue, double newValue)` Overriden for performance reasons.
    `void` | `firePropertyChange(String propertyName, float oldValue, float newValue)` Overriden for performance reasons.
    `void` | `firePropertyChange(String propertyName, long oldValue, long newValue)` Overriden for performance reasons.
    `protected void` | `firePropertyChange(String propertyName, Object oldValue, Object newValue)` Overriden for performance reasons.
    `void` | `firePropertyChange(String propertyName, short oldValue, short newValue)` Overriden for performance reasons.
    `protected Color` | `getCalendarBackground(ICalendarModel calendarModel, IDatelineModel datelineModel, long time)` Returns a background color for the given time point, calendar model and dateline model.
    `Color` | `getCalendarEntryBackground(Class calendarEntryType)` Returns the background color that will be used for drawing time spans that intersect with calendar entries of the given type.
    `Color` | `getCalendarEntryForeground(Class calendarEntryType)` Returns the foreground color that will be used for drawing time spans that intersect with calendar entries of the given type.
    `protected Color` | `getCalendarForeground(ICalendarModel calendarModel, IDatelineModel datelineModel, long time)` Returns a foreground color for the given time point, calendar model and dateline model.
    `Dateline` | `getDateline()` Returns the dateline for which rendering currently takes place.
    `Component` | `getDatelineRendererComponent(Dateline dateline, T model, ITimeSpan timeSpan, boolean major, boolean focus)` Returns the renderer component that will be used by the dateline to render a time span that can be located on the major or the minor part of the dateline.
    `Color` | `getFocusBackground()` Returns the background color that will be used for drawing a time span when the time span has the focus (the mouse cursor hovers on top of the time span).
    `Color` | `getFocusForeground()` Returns the foreground color that will be used for drawing a time span when the time span has the focus (the mouse cursor hovers on top of the time span).
    `Icon` | `getIcon()` Returns the icon used by the renderer.
    `protected Color` | `getMajorBackground(Dateline dateline, long date)` Returns the background color for the given time point that is placed on the upper (the major) part of the dateline.
    `protected Color` | `getMajorForeground(Dateline dateline, long date)` Returns the foreground color for the given time point that is placed on the upper (the major) part of the dateline.
    `protected Color` | `getMinorBackground(Dateline dateline, long date)` Returns the background color for the given time point that is placed on the lower (the minor) part of the dateline.
    `protected Color` | `getMinorForeground(Dateline dateline, long date)` Returns the foreground color for the given time point that is placed on the lower (the minor) part of the dateline.
    `T` | `getModel()` Returns the dateline model that returned the time span that is currently being rendered.
    `String` | `getText()` Returns the text that will be shown by the renderer in the currently drawn time span cell.
    `ITimeSpan` | `getTimeSpan()` Returns the time span that is currently being rendered.
    `boolean` | `hasFocus()` Determines whether the currently rendered time span (cell) is the focus owner.
    `void` | `invalidate()` Overriden for performance reasons.
    `boolean` | `isFocusedTimeVisible()` Determines whether the renderer will visualize which time span currently has the focus.
    `boolean` | `isMajor()` Returns TRUE if the currently rendered time span (cell) is located in the upper (major) section of the dateline.
    `boolean` | `isVisible()` Overriden in order to fix a bug in AWT, which causes the cursor to flicker during drag and drop operations.
    `void` | `repaint()` Overriden for performance reasons.
    `void` | `repaint(int x, int y, int width, int height)` Overriden for performance reasons.
    `void` | `repaint(long tm)` Overriden for performance reasons.
    `void` | `revalidate()` Overriden for performance reasons.
    `void` | `setCalendarEntryBackground(Class calendarEntryType, Color color)` Sets the background color that will be used for drawing time spans that intersect with calendar entries of the given type.
    `void` | `setCalendarEntryForeground(Class calendarEntryType, Color color)` Sets the foreground color that will be used for drawing time spans that intersect with calendar entries of the given type.
    `void` | `setFocusBackground(Color color)` Sets the background color that will be used for drawing a time span when the time span has the focus (the mouse cursor hovers on top of the time span).
    `void` | `setFocusedTimeVisible(boolean visible)` Specifies whether the renderer will visualize which time span currently has the focus.
    `void` | `setFocusForeground(Color color)` Sets the foreground color that will be used for drawing a time span when the time span has the focus (the mouse cursor hovers on top of the time span).
    `void` | `setIcon(Icon icon)` Sets the icon used by the renderer.
    `void` | `setText(String text)` Sets the text that will be shown by the renderer in the currently drawn time span cell.
    `void` | `validate()` Overriden for performance reasons.

    - ### Methods inherited from class javax.swing.JLabel

      `checkHorizontalKey, checkVerticalKey, getAccessibleContext, getDisabledIcon, getDisplayedMnemonic, getDisplayedMnemonicIndex, getHorizontalAlignment, getHorizontalTextPosition, getIconTextGap, getLabelFor, getUI, getUIClassID, getVerticalAlignment, getVerticalTextPosition, imageUpdate, paramString, setDisabledIcon, setDisplayedMnemonic, setDisplayedMnemonic, setDisplayedMnemonicIndex, setHorizontalAlignment, setHorizontalTextPosition, setIconTextGap, setLabelFor, setUI, setVerticalAlignment, setVerticalTextPosition, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractDatelineRenderer

          protected AbstractDatelineRenderer()

      Constructs a new dateline renderer and initializes the forground and background colors for calendar entries that are of type or subclasses of `WeekendCalendarEntry` and `HolidayCalendarEntry`.
      Since:
        1.0
      See Also:
        `setCalendarEntryForeground(Class, Color)`, `setCalendarEntryBackground(Class, Color)`

  - ### Method Detail

    - #### setFocusedTimeVisible

          public void setFocusedTimeVisible(boolean visible)

      Specifies whether the renderer will visualize which time span currently has the focus. The focused time span will have a different background color.
      Parameters:
        `visible` - if true the cell with the focused time span will have a different background color (default is TRUE)
      Since:
        2.0
      See Also:
        `Dateline.getFocusBackground()`

    - #### isFocusedTimeVisible

          public boolean isFocusedTimeVisible()

      Determines whether the renderer will visualize which time span currently has the focus. The focused time span will have a different background color.
      Returns:
        TRUE (default) if the focused time span will be visible
      Since:
        2.0
      See Also:
        `Dateline.getFocusBackground()`

    - #### getDatelineRendererComponent

          public Component getDatelineRendererComponent(Dateline dateline,
                                                        T model,
                                                        ITimeSpan timeSpan,
                                                        boolean major,
                                                        boolean focus)

      Returns the renderer component that will be used by the dateline to render a time span that can be located on the major or the minor part of the dateline. The renderer supports a focus attribute that tells the renderer whether the mouse cursor is currently on top of the time span. This visual feedback is important so that the user knows into which time span the dateline will zoom into when the left mouse button gets clicked. The abstract renderer stores all method parameters in protected fields that can be used by concrete subclasses. In order for this to work the subclasses must always make sure to call this super method.
      Specified by:
        `getDatelineRendererComponent` in interface `IDatelineRenderer<T extends IDatelineModel>`
      Parameters:
        `dateline` - the dateline component
        `model` - the dateline model that returned / specified the given time span
        `timeSpan` - the time span to render
        `major` - a flag that signals whether the time span is located on the upper or the lower part of the dateline
        `focus` - a flag indicating whether the time span has the focus
      Returns:
        a component used for the actual rendering of the time span
      Since:
        1.0

    - #### getMajorForeground

          protected Color getMajorForeground(Dateline dateline,
                                             long date)

      Returns the foreground color for the given time point that is placed on the upper (the major) part of the dateline. The color will either be the foreground color of the timeline or the focus foreground color defined by the renderer itself.
      Parameters:
        `dateline` - the component in which the time span will be renderered
        `date` - the start time of the time span
      Returns:
        a foreground color for a major time span
      Since:
        1.0
      See Also:
        `getMinorForeground(Dateline, long)`, `getMajorBackground(Dateline, long)`

    - #### getMajorBackground

          protected Color getMajorBackground(Dateline dateline,
                                             long date)

      Returns the background color for the given time point that is placed on the upper (the major) part of the dateline. The color will either be the background color of the timeline or the focus background color defined by the renderer itself.
      Parameters:
        `dateline` - the component in which the time span will be renderered
        `date` - the start time of the time span
      Returns:
        a foreground color for a major time span
      Since:
        1.0
      See Also:
        `getMinorBackground(Dateline, long)`, `getMajorForeground(Dateline, long)`

    - #### getMinorForeground

          protected Color getMinorForeground(Dateline dateline,
                                             long date)

      Returns the foreground color for the given time point that is placed on the lower (the minor) part of the dateline. The color will either be:
      - the foreground color of the timeline
      - the focus foreground color defined by the renderer itself
      - a color based on a calendar entry
      Parameters:
        `dateline` - the component in which the time span will be renderered
        `date` - the start time of the time span
      Returns:
        a foreground color for a minor time span
      Since:
        1.0
      See Also:
        `getFocusForeground()`, `getCalendarForeground(ICalendarModel, IDatelineModel, long)`, `getMinorBackground(Dateline, long)`, `getMajorForeground(Dateline, long)`, `getCalendarEntryForeground(Class)`

    - #### getMinorBackground

          protected Color getMinorBackground(Dateline dateline,
                                             long date)

      Returns the background color for the given time point that is placed on the lower (the minor) part of the dateline. The color will either be:
      - the background color of the timeline
      - the focus background color defined by the renderer itself
      - a color based on a calendar entry
      Parameters:
        `dateline` - the component in which the time span will be renderered
        `date` - the start time of the time span
      Returns:
        a background color for a minor time span
      Since:
        1.0
      See Also:
        `getFocusForeground()`, `getCalendarForeground(ICalendarModel, IDatelineModel, long)`, `getMinorBackground(Dateline, long)`, `getMajorForeground(Dateline, long)`, `getCalendarEntryForeground(Class)`

    - #### getCalendarForeground

          protected Color getCalendarForeground(ICalendarModel calendarModel,
                                                IDatelineModel datelineModel,
                                                long time)

      Returns a foreground color for the given time point, calendar model and dateline model. The method checks the calendar model if any calendar entries are located at the given time point. The dateline model gets passed to the calendar model for this check. The method returns NULL if no calendar entries can be found or if no color is mapped to the calendar entries that were found. Several calendar entries might exist at the given time point. In this case the color of the first calendar entry for which a foreground color mapping exists will be returned.
      Parameters:
        `calendarModel` - the Gantt chart's calendar model
        `datelineModel` - the model used by the dateline
        `time` - the time point for which to return a foreground color
      Returns:
        a foreground color for the given time that takes the Gantt chart's calendar model into consideration
      Since:
        1.0
      See Also:
        `getCalendarEntryForeground(Class)`

    - #### getCalendarBackground

          protected Color getCalendarBackground(ICalendarModel calendarModel,
                                                IDatelineModel datelineModel,
                                                long time)

      Returns a background color for the given time point, calendar model and dateline model. The method checks the calendar model if any calendar entries are located at the given time point. The dateline model gets passed to the calendar model for this check. The method returns NULL if no calendar entries can be found or if no color is mapped to the calendar entries that were found. Several calendar entries might exist at the given time point. In this case the color of the first calendar entry for which a background color mapping exists will be returned.
      Parameters:
        `calendarModel` - the Gantt chart's calendar model
        `datelineModel` - the model used by the dateline
        `time` - the time point for which to return a background color
      Returns:
        a background color for the given time that takes the Gantt chart's calendar model into consideration
      Since:
        1.0
      See Also:
        `getCalendarEntryBackground(Class)`

    - #### setCalendarEntryForeground

          public void setCalendarEntryForeground(Class calendarEntryType,
                                                 Color color)

      Sets the foreground color that will be used for drawing time spans that intersect with calendar entries of the given type.
      Parameters:
        `calendarEntryType` - the object type of the calendar entries
        `color` - the color used for drawing the time span foreground
      Since:
        1.0
      See Also:
        `getCalendarEntryForeground(Class)`, `setCalendarEntryBackground(Class, Color)`

    - #### getCalendarEntryForeground

          public Color getCalendarEntryForeground(Class calendarEntryType)

      Returns the foreground color that will be used for drawing time spans that intersect with calendar entries of the given type.
      Parameters:
        `calendarEntryType` - the calendar entry type
      Returns:
        a foreground color that will be used for drawing the time span
      Since:
        1.0
      See Also:
        `setCalendarEntryForeground(Class, Color)`, `getCalendarEntryBackground(Class)`

    - #### setCalendarEntryBackground

          public void setCalendarEntryBackground(Class calendarEntryType,
                                                 Color color)

      Sets the background color that will be used for drawing time spans that intersect with calendar entries of the given type.
      Parameters:
        `calendarEntryType` - the object type of the calendar entries
        `color` - the color used for drawing the time span background
      Since:
        1.0
      See Also:
        `getCalendarEntryBackground(Class)`, `setCalendarEntryForeground(Class, Color)`

    - #### getCalendarEntryBackground

          public Color getCalendarEntryBackground(Class calendarEntryType)

      Returns the background color that will be used for drawing time spans that intersect with calendar entries of the given type.
      Parameters:
        `calendarEntryType` - the calendar entry type
      Returns:
        a background color object that will be used for drawing the time span
      Since:
        1.0
      See Also:
        `setCalendarEntryBackground(Class, Color)`, `getCalendarEntryForeground(Class)`

    - #### setFocusBackground

          public void setFocusBackground(Color color)

      Sets the background color that will be used for drawing a time span when the time span has the focus (the mouse cursor hovers on top of the time span).
      Parameters:
        `color` - the focus background color
      Since:
        1.0
      See Also:
        `getFocusBackground()`

    - #### getFocusBackground

          public Color getFocusBackground()

      Returns the background color that will be used for drawing a time span when the time span has the focus (the mouse cursor hovers on top of the time span).
      Returns:
        the focus background color
      Since:
        1.0

    - #### setFocusForeground

          public void setFocusForeground(Color color)

      Sets the foreground color that will be used for drawing a time span when the time span has the focus (the mouse cursor hovers on top of the time span).
      Parameters:
        `color` - the focus foreground color
      Since:
        1.0
      See Also:
        `getFocusForeground()`

    - #### getFocusForeground

          public Color getFocusForeground()

      Returns the foreground color that will be used for drawing a time span when the time span has the focus (the mouse cursor hovers on top of the time span).
      Returns:
        the focus foreground color
      Since:
        1.0

    - #### getDateline

          public Dateline getDateline()

      Returns the dateline for which rendering currently takes place.
      Returns:
        the dateline UI component
      Since:
        1.0

    - #### hasFocus

          public boolean hasFocus()

      Determines whether the currently rendered time span (cell) is the focus owner. This method does not follow the 'isFocused' naming pattern in order to avoid confusion with the superclass method 'hasFocus'.
      Overrides:
        `hasFocus` in class `Component`
      Since:
        1.0

    - #### isMajor

          public boolean isMajor()

      Returns TRUE if the currently rendered time span (cell) is located in the upper (major) section of the dateline.
      Returns:
        TRUE if the renderer is used for rendering a major time span
      Since:
        1.0

    - #### getModel

          public T getModel()

      Returns the dateline model that returned the time span that is currently being rendered.
      Returns:
        the dateline model
      Since:
        1.0

    - #### getTimeSpan

          public ITimeSpan getTimeSpan()

      Returns the time span that is currently being rendered.
      Returns:
        the rendered time span
      Since:
        1.0

    - #### getIcon

          public Icon getIcon()

      Returns the icon used by the renderer.
      Overrides:
        `getIcon` in class `JLabel`
      Returns:
        the icon shown in the time span cell
      Since:
        1.0

    - #### setIcon

          public void setIcon(Icon icon)

      Sets the icon used by the renderer.
      Overrides:
        `setIcon` in class `JLabel`
      Parameters:
        `icon` - the icon shown in the time span cell
      Since:
        1.0

    - #### getText

          public String getText()

      Returns the text that will be shown by the renderer in the currently drawn time span cell.
      Overrides:
        `getText` in class `JLabel`
      Returns:
        the renderer's text
      Since:
        1.0

    - #### setText

          public void setText(String text)

      Sets the text that will be shown by the renderer in the currently drawn time span cell.
      Overrides:
        `setText` in class `JLabel`
      Parameters:
        `text` - the renderer's text
      Since:
        1.0

    - #### validate

          public void validate()

      Overriden for performance reasons.
      Overrides:
        `validate` in class `Container`
      Since:
        1.0

    - #### invalidate

          public void invalidate()

      Overriden for performance reasons.
      Overrides:
        `invalidate` in class `Container`
      Since:
        1.0

    - #### revalidate

          public void revalidate()

      Overriden for performance reasons.
      Overrides:
        `revalidate` in class `JComponent`
      Since:
        1.0

    - #### firePropertyChange

          public void firePropertyChange(String propertyName,
                                         boolean oldValue,
                                         boolean newValue)

      Overriden for performance reasons.
      Overrides:
        `firePropertyChange` in class `JComponent`
      Since:
        1.0

    - #### firePropertyChange

          public void firePropertyChange(String propertyName,
                                         byte oldValue,
                                         byte newValue)

      Overriden for performance reasons.
      Overrides:
        `firePropertyChange` in class `Component`
      Since:
        1.0

    - #### firePropertyChange

          public void firePropertyChange(String propertyName,
                                         char oldValue,
                                         char newValue)

      Overriden for performance reasons.
      Overrides:
        `firePropertyChange` in class `JComponent`
      Since:
        1.0

    - #### firePropertyChange

          public void firePropertyChange(String propertyName,
                                         double oldValue,
                                         double newValue)

      Overriden for performance reasons.
      Overrides:
        `firePropertyChange` in class `Component`
      Since:
        1.0

    - #### firePropertyChange

          public void firePropertyChange(String propertyName,
                                         float oldValue,
                                         float newValue)

      Overriden for performance reasons.
      Overrides:
        `firePropertyChange` in class `Component`
      Since:
        1.0

    - #### firePropertyChange

          public void firePropertyChange(String propertyName,
                                         long oldValue,
                                         long newValue)

      Overriden for performance reasons.
      Overrides:
        `firePropertyChange` in class `Component`
      Since:
        1.0

    - #### firePropertyChange

          protected void firePropertyChange(String propertyName,
                                            Object oldValue,
                                            Object newValue)

      Overriden for performance reasons.
      Overrides:
        `firePropertyChange` in class `Component`
      Since:
        1.0

    - #### firePropertyChange

          public void firePropertyChange(String propertyName,
                                         short oldValue,
                                         short newValue)

      Overriden for performance reasons.
      Overrides:
        `firePropertyChange` in class `Component`
      Since:
        1.0

    - #### repaint

          public void repaint()

      Overriden for performance reasons.
      Overrides:
        `repaint` in class `Component`
      Since:
        1.0

    - #### repaint

          public void repaint(int x,
                              int y,
                              int width,
                              int height)

      Overriden for performance reasons.
      Overrides:
        `repaint` in class `Component`
      Since:
        1.0

    - #### repaint

          public void repaint(long tm)

      Overriden for performance reasons.
      Overrides:
        `repaint` in class `Component`
      Since:
        1.0

    - #### isVisible

          public boolean isVisible()

      Overriden in order to fix a bug in AWT, which causes the cursor to flicker during drag and drop operations.
      Overrides:
        `isVisible` in class `Component`
      Since:
        1.1

Copyright © 2006–2020 Dirk Lemmermann Software & Consulting. All rights reserved.